# coding: utf-8

"""
    Netilion API Documentation

    Welcome to the Netilion API Documentation, which provides interactive access and documentation to our REST API. Please visit our developer portal for further instructions and information: https://developer.netilion.endress.com/   # noqa: E501

    OpenAPI spec version: 01.00.00
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InstrumentationBase(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tag': 'str',
        'description': 'str',
        'criticality': 'str',
        'accessibility': 'str'
    }

    attribute_map = {
        'tag': 'tag',
        'description': 'description',
        'criticality': 'criticality',
        'accessibility': 'accessibility'
    }

    discriminator_value_class_map = {
          'InstrumentationRequest': 'InstrumentationRequest',
'InstrumentationResponse': 'InstrumentationResponse'    }

    def __init__(self, tag=None, description=None, criticality=None, accessibility=None):  # noqa: E501
        """InstrumentationBase - a model defined in Swagger"""  # noqa: E501
        self._tag = None
        self._description = None
        self._criticality = None
        self._accessibility = None
        self.discriminator = 'instrumentationBaseType'
        if tag is not None:
            self.tag = tag
        if description is not None:
            self.description = description
        if criticality is not None:
            self.criticality = criticality
        if accessibility is not None:
            self.accessibility = accessibility

    @property
    def tag(self):
        """Gets the tag of this InstrumentationBase.  # noqa: E501

        Instrumentation tag. The value must be unique if under a parent instrumentation  # noqa: E501

        :return: The tag of this InstrumentationBase.  # noqa: E501
        :rtype: str
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this InstrumentationBase.

        Instrumentation tag. The value must be unique if under a parent instrumentation  # noqa: E501

        :param tag: The tag of this InstrumentationBase.  # noqa: E501
        :type: str
        """

        self._tag = tag

    @property
    def description(self):
        """Gets the description of this InstrumentationBase.  # noqa: E501

        description text of the Instrumentation  # noqa: E501

        :return: The description of this InstrumentationBase.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InstrumentationBase.

        description text of the Instrumentation  # noqa: E501

        :param description: The description of this InstrumentationBase.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def criticality(self):
        """Gets the criticality of this InstrumentationBase.  # noqa: E501

        possible values are: undefined, low, medium and high. Undefined is assigned per default  # noqa: E501

        :return: The criticality of this InstrumentationBase.  # noqa: E501
        :rtype: str
        """
        return self._criticality

    @criticality.setter
    def criticality(self, criticality):
        """Sets the criticality of this InstrumentationBase.

        possible values are: undefined, low, medium and high. Undefined is assigned per default  # noqa: E501

        :param criticality: The criticality of this InstrumentationBase.  # noqa: E501
        :type: str
        """

        self._criticality = criticality

    @property
    def accessibility(self):
        """Gets the accessibility of this InstrumentationBase.  # noqa: E501

        possible values are: undefined, easy, moderate and difficult. Undefined is assigned per default  # noqa: E501

        :return: The accessibility of this InstrumentationBase.  # noqa: E501
        :rtype: str
        """
        return self._accessibility

    @accessibility.setter
    def accessibility(self, accessibility):
        """Sets the accessibility of this InstrumentationBase.

        possible values are: undefined, easy, moderate and difficult. Undefined is assigned per default  # noqa: E501

        :param accessibility: The accessibility of this InstrumentationBase.  # noqa: E501
        :type: str
        """

        self._accessibility = accessibility

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_value = data[self.discriminator].lower()
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InstrumentationBase, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstrumentationBase):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
